<template>
  <section>
    <client-only>
      <template v-slot:placeholder>
        <v-skeleton-loader type="image" height="100%" light />
      </template>
      <keep-alive>
        <div ref="node" style="width: 100%; height: calc(100vh - 96px)" />
      </keep-alive>

      <v-card v-show="initialized" class="d-flex px-2 py-1 map-as-move">
        <v-checkbox
          v-model="asIMove"
          color="accent"
          hide-details
          class="pa-0 ma-0"
          dense
          label="Search as I move"
        />
      </v-card>
      <v-btn
        v-show="initialized"
        class="map-pencil caption accent--text"
        depressed
        elevation="2"
        :ripple="false"
        width="70"
        height="80"
        @click="toggleEditMode"
      >
        <v-icon size="30" color="accent">
          {{ hasPolygon ? mdiPencilRemoveOutline : editingMode ? mdiPencilOffOutline : mdiPencilOutline }}
        </v-icon>
        <span class="text-capitalize">
          Draw<br>Search
        </span>
      </v-btn>
      <v-card v-show="initialized" class="d-flex py-3 px-0 flex-column map-zooms">
        <v-btn
          tile
          text
          color="accent"
          class="px-0"
          x-small
          width="28"
          height="28"
          @click="zoomIn"
        >
          <v-icon>
            {{ mdiPlus }}
          </v-icon>
        </v-btn>
        <v-btn
          tile
          text
          color="accent"
          x-small
          width="28"
          height="28"
          class="mt-1 px-0"
          @click="zoomOut"
        >
          <v-icon>
            {{ mdiMinus }}
          </v-icon>
        </v-btn>
      </v-card>
    </client-only>
  </section>
</template>

<style>
.map-zooms {
  position: absolute;
  z-index: 2000;
  bottom: 50px;
  left: 16px;
}
.map-pencil {
  position: absolute;
  z-index: 2000;
  top: 20px;
  right: 16px;
}
.map-pencil .v-btn__content {
  flex-direction: column;
}
.map-as-move {
  position: absolute;
  z-index: 2000;
  top: 20px;
  left: 16px;
}
</style>

<script lang="ts">
import { mdiPlus, mdiMinus, mdiPencilOffOutline, mdiPencilOutline, mdiPencilRemoveOutline } from '@mdi/js'
import { defineComponent, computed, reactive, toRefs, watch, ref } from '@vue/composition-api'
import { useQuery, useGMap, useDraw } from '../hooks'
import { formatFullAddress } from '~/utils'

type Polygon = {
  type: 'Polygon',
  coordinates: [number, number][][]
}
type MultiPolygon = {
  type: 'MultiPolygon',
  coordinates: [number, number][][][]
}
type NomResponse = {
  importance: number,
  // eslint-disable-next-line
  osm_id: number
  geometry: Polygon | MultiPolygon
}

export default defineComponent({
  name: 'AppMap',
  props: {
    visible: Boolean
  },
  setup (props, context) {
    let hasMoved = false
    const { setFilter, filters, coordinates } = useQuery(context, ['view'])
    const { onMapInit, google, map, node, initialized } = useGMap({
      center: { lat: 32.779167, lng: -96.808891 },
      zoom: 10,
      disableDefaultUI: true
    })
    const bounds = ref<google.maps.LatLngBounds>(null)
    const { polygon, isDrawing } = useDraw(google, map)
    // Map Options
    const options = reactive({
      asIMove: true,
      editingMode: isDrawing,
      showBoundaries: true
    })

    const hasPolygon = computed(() => !!filters.value.mapPolygon)
    const hasView = computed(() => !!filters.value.view)
    const zoomIn = () => map.value?.setZoom(map.value?.getZoom() + 1)
    const zoomOut = () => map.value?.setZoom(map.value?.getZoom() - 1)
    const iconSrc = require('@/assets/img/map-icon.png')
    let infoWindow: google.maps.InfoWindow
    const toLatLngArray = (bound: google.maps.LatLngBounds) => {
      if (!bound) { return null }
      const south = bound.getSouthWest()
      const north = bound.getNorthEast()
      return [[south.lat(), south.lng()], [north.lat(), north.lng()]]
    }
    watch(() => String(toLatLngArray(bounds.value)), () => {
      if (map.value && bounds.value) {
        map.value.fitBounds(bounds.value, 0)
      }
    }, { lazy: true })
    function updateView () {
      if (!options.asIMove || !props.visible) { return }
      if (bounds.value) {
        const latlng = toLatLngArray(bounds.value)
        if (latlng[0][0] !== latlng[1][0] && latlng[0][1] !== latlng[1][1]) {
          setFilter('view', latlng)
        }
      }
    }

    // Google map initialization
    onMapInit((initMap) => {
      initMap.addListener('dragstart', () => {
        if (options.asIMove) {
          context.emit('is-moving', true)
        }
      })
      initMap.addListener('dragend', () => {
        if (options.asIMove) {
          hasMoved = true
          setFilter('locationComp', ['texas'])
          setFilter('search', undefined)
        }
      })
      initMap.addListener('idle', () => {
        if (options.asIMove) {
          context.emit('is-moving', false)
          if (props.visible) {
            bounds.value = map.value.getBounds()
          }
          if (hasMoved) { updateView() }
        }
      })
      createCityBorders()
    })

    watch(polygon, () => {
      if (!polygon.value) { return }
      const poly: [number, number][] = polygon.value
        .getPath()
        .getArray()
        .map(({ lat, lng }) => [lat(), lng()])

      setFilter('mapPolygon', [poly])
    }, { lazy: true })

    let cityPoly: google.maps.Polygon | undefined

    async function createCityBorders (initializing: boolean = false): void {
      let sw: [number, number]
      let ne: [number, number]

      if (!initialized.value || !map.value || !node.value || !google.value) { return }

      if (cityPoly) {
        cityPoly.setMap(null)
      }
      hasMoved = false
      if (!filters.value.locationComp) { return }
      const BORDER_API = 'https://nominatim.openstreetmap.org'
      const places: NomResponse[] = await context.root.$axios.$get(
        `${BORDER_API}/search.php?format=json&countrycodes=us&state=texas&q=` + filters.value.locationComp.slice().reverse().join(', ')
      )
      if (!places.length && places[0].importance < 0.5) { return }

      if (!initializing || !filters.value.view) {
        sw = [+places[0].boundingbox[0], +places[0].boundingbox[2]]
        ne = [+places[0].boundingbox[1], +places[0].boundingbox[3]]
      } else if (filters.value.view) {
        [sw, ne] = filters.value.view
      }
      bounds.value = new google.value.maps.LatLngBounds(
        new google.value.maps.LatLng(...sw),
        new google.value.maps.LatLng(...ne)
      )
      const place: NomResponse = await context.root.$axios.$get(
        `${BORDER_API}/details.php?osmtype=R&format=json&polygon_geojson=1&osmid=` + places[0].osm_id
      )
      const placePoly = place.geometry.type === 'Polygon' ? place.geometry.coordinates : place.geometry.coordinates[0]
      const paths = placePoly
        .map(v => v.map(([lng, lat]) => new google.value!.maps.LatLng(lat, lng)))

      cityPoly = new google.value.maps.Polygon({
        paths,
        map: map.value,
        strokeOpacity: 0.6,
        strokeWeight: 2,
        fillOpacity: 0
      })
    }

    watch(isDrawing, () => {
      if (isDrawing.value && cityPoly) {
        cityPoly.setMap(null)
      } else if (!isDrawing.value && !polygon.value && !hasMoved) {
        createCityBorders()
        updateView()
      }
    }, { lazy: true })

    watch(() => String(filters.value.search), () => {
      if (filters.value.search) {
        createCityBorders()
      }
    }, { lazy: true })

    function toggleEditMode () {
      if (polygon.value) {
        setFilter('mapPolygon', undefined)
        polygon.value.setMap(null)
        polygon.value = null
        options.editingMode = false
      } else {
        options.editingMode = !options.editingMode
      }
    }

    // Main loop property refresh
    const markers: google.maps.Marker[] = []
    watch(coordinates, () => {
      if (!initialized.value || !map.value || !node.value || !google.value) { return }
      markers.map(m => m.setMap(null))
      markers.length = 0
      if (coordinates.value.length === 0) { return }
      console.log(map.value.getDiv())
      for (let index = 0; index < coordinates.value.length; index++) {
        const property = coordinates.value[index]
        const [lng, lat] = property.address.location.coordinates

        const position = new google.value.maps.LatLng(lat, lng)
        const marker = new google.value.maps.Marker({
          map: map.value,
          position,
          icon: {
            url: iconSrc,
            scaledSize: new google.value.maps.Size(20, 20)
          }
        })
        marker.addListener('mouseover', () => {
          if (google.value) {
            infoWindow = new google.value.maps.InfoWindow({
              content: `
                <div class="d-flex align-end">
                  <div>
                    <h2>${property.name}</h2>
                    <br><span>${formatFullAddress(property)}</span>
                  </div>
                </div>
              `
            })
            infoWindow.open(map.value!, marker)
          }
        })
        marker.addListener('mouseout', () => {
          infoWindow.close()
        })
        marker.addListener('click', () => {
          context.root.$router.push({ name: 'apartment-id', params: { id: property.id } })
        })
        markers.push(marker)
      }
    }, { lazy: true })

    return {
      ...toRefs(options),
      node,
      initialized,
      hasPolygon,
      toggleEditMode,
      hasView,
      zoomIn,
      zoomOut,
      mdiPlus,
      mdiMinus,
      mdiPencilOffOutline,
      mdiPencilOutline,
      mdiPencilRemoveOutline
    }
  }
})
</script>
